<?php

function plugin_init_superlinks() {
	global $plugin_hooks, $superlinks_nav;

	$superlinks_nav["superlinks.php:"] = array("title" => "SuperLinks", "mapping" => "", "url" => "superlinks.php", "level" => "1");
	$superlinks_nav["superlinks-mgmt.php:"] = array("title" => "SuperLinks Admin", "mapping" => "", "url" => "superlinks-mgmt.php", "level" => "1");
	$superlinks_nav["superlinks-mgmt.php:addpage_picker"] = array("title" => "SuperLinks Admin", "mapping" => "", "url" => "superlinks-mgmt.php", "level" => "1");
	$superlinks_nav["superlinks-mgmt.php:edit"] = array("title" => "SuperLinks Admin", "mapping" => "", "url" => "superlinks-mgmt.php", "level" => "1");
	$superlinks_nav["superlinks-mgmt.php:perms_edit"] = array("title" => "SuperLinks Admin", "mapping" => "", "url" => "superlinks-mgmt.php", "level" => "1");

	$plugin_hooks['top_header_tabs']['superlinks'] = 'superlinks_show_tab';
	$plugin_hooks['top_graph_header_tabs']['superlinks'] = 'superlinks_show_tab';

	$plugin_hooks['config_arrays']['superlinks'] = 'superlinks_config_arrays';
	$plugin_hooks['config_settings']['superlinks'] = 'superlinks_config_settings';
	$plugin_hooks['draw_navigation_text']['superlinks'] = 'superlinks_draw_navigation_text';
	$plugin_hooks['console_after']['superlinks'] = 'superlinks_console_after';
	$plugin_hooks['login_after']['superlinks'] = 'superlinks_login_after';
	$plugin_hooks['login_before']['superlinks'] = 'superlinks_login_before';

}

function superlinks_config_settings () {
        global $tabs, $settings;
        $tabs["misc"] = "Misc";

        $temp = array(
                "superlinks_header" => array(
                        "friendly_name" => "SuperLinks",
                        "method" => "spacer",
                ),
                "superlinks_tabstyle" => array(
                        "friendly_name" => "Tab style",
                        "description" => "Which size tabs to use?",
                        "method" => "drop_array",
                        "array" => array(0 => "Regular", 1 => "Smaller")
                )
		);
        if (isset($settings["misc"]))
                $settings["misc"] = array_merge($settings["misc"], $temp);
        else
                $settings["misc"]=$temp;
}

function superlinks_common_inpage($type, $add_hr=0, $add_heading=0)
{
	global $config;

	$userid=0;

	if(isset($_SESSION['sess_user_id']))
	{
		$userid = $_SESSION["sess_user_id"];
	}

	$queryrows = db_fetch_assoc("select distinct id,title,contentfile from superlinks_pages, superlinks_auth where superlinks_pages.id=superlinks_auth.pageid and style='$type' and (userid=$userid or userid=0) order by sortorder,id");

                if(sizeof($queryrows) > 0)
                {
			if($add_hr) print "<hr>";
			foreach ($queryrows as $page) {
		                $my_file = $config["base_path"] . "/plugins/superlinks/content/".$page['contentfile'];
			
				if ($add_heading) print "<h3>".$page['title']."</h3>";

			        if (preg_match('/^((((ht|f)tp(s?))\:\/\/){1}\S+)/i',$page['contentfile'])) {
                			print '<iframe src="' . $page['contentfile'] . '" width="100%" height="100%" frameborder="0"></iframe><br>';
        			} else {
                			print '<div>';

		               		 if (file_exists($my_file)) {
               			        	 @include_once($my_file);
                			} else {
                        			print '<h1>The File Does not appear to exist!!</h1>';
                			}

		                	print '</div>';
        			}
                        }
		}
}

function superlinks_login_before()
{
	superlinks_common_inpage("LOGINBEFORE", 1,1);
}

function superlinks_login_after()
{
	superlinks_common_inpage("LOGINAFTER", 1,1);
}


function superlinks_console_after()
{
	superlinks_common_inpage("FRONT", 1,1);
}

function superlinks_config_arrays () {
        global $user_auth_realms, $user_auth_realm_filenames, $menu;
	global $cnn_id;
	global $config, $database_default;
	global $database_hostname, $database_username, $database_password, $database_default, $database_type, $database_port;

        $realm_id2 = 0;
        
	$user_auth_realms[141]='Plugin -> SuperLinks: View Pages';
        $user_auth_realm_filenames['superlinks.php'] = 141;
		
	$user_auth_realms[142]='Plugin -> SuperLinks: Manage Pages';
        $user_auth_realm_filenames['superlinks-mgmt.php'] = 142;
		
	$menu["Management"]['plugins/superlinks/superlinks-mgmt.php'] = "SuperLinks Pages"; 	
	
	# $menu["Extra"]['plugins/superlinks/superlinks.php?id=2'] = "Test";
		
	if( isset($_SESSION['sess_user_id']))
	{
		// Calling this a little earlier than normal			
		db_connect_real($database_hostname, $database_username, $database_password, $database_default, $database_type, $database_port);

       		 if (isset($user_auth_realm_filenames['superlinks.php'])) {
                       	$realm_id2 = $user_auth_realm_filenames['superlinks.php'];
       		}

		if ((db_fetch_assoc("select user_auth_realm.realm_id from user_auth_realm where user_auth_realm.user_id='" . $_SESSION["sess_user_id"] . "' and user_auth_realm.realm_id='$realm_id2'")) || (empty($realm_id2)))
       		{
			$queryrows=array();
			//  db_fetch_assoc tries to access config settings which aren't there yet, so this is a little bodge to get the necessary info
			/////// $queryrows = db_fetch_assoc("select distinct id,title from superlinks_pages, superlinks_auth where superlinks_pages.id=superlinks_auth.pageid and style='CONSOLE' and (userid=".$_SESSION["sess_user_id"]." or userid=0) order by sortorder,id");	
			$SQL = "select distinct id,title from superlinks_pages, superlinks_auth where superlinks_pages.id=superlinks_auth.pageid and style='CONSOLE' and (userid=".$_SESSION["sess_user_id"]." or userid=0) order by sortorder,id";
			$cnn_id->SetFetchMode(ADODB_FETCH_ASSOC);
			$query = $cnn_id->Execute($SQL);
			if ($query) {
				while ((!$query->EOF) && ($query)) {
					$queryrows{sizeof($queryrows)} = $query->fields;
					$query->MoveNext();
				}
			}
	
			$tmp = $menu["Utilities"];
			unset( $menu["Utilities"]); 
	
			if(sizeof($queryrows) > 0)
			{
				foreach ($queryrows as $page) {
					$menu["Extra"]["plugins/superlinks/superlinks.php?id=".$page['id']] = $page['title'];
				}
			}

			$menu["Utilities"] = $tmp;
		}	
	}	
}

function superlinks_show_tab () {
	global $config, $user_auth_realms, $user_auth_realm_filenames;

	$realm_id2 = 0;

	superlinks_setup_table();
	
	if (isset($user_auth_realm_filenames['superlinks.php'])) {
			$realm_id2 = $user_auth_realm_filenames['superlinks.php'];
	}

	$tabstyle = read_config_option("superlinks_tabstyle");
	
	if ((db_fetch_assoc("select user_auth_realm.realm_id from user_auth_realm where user_auth_realm.user_id='" . $_SESSION["sess_user_id"] . "' and user_auth_realm.realm_id='$realm_id2'")) || (empty($realm_id2))) 
	{
		# print '<a href="' . $config['url_path'] . 'plugins/superlinks/superlinks.php"><img src="' . $config['url_path'] . 'plugins/superlinks/images/tab_links.png" alt="Links" align="absmiddle" border="0"></a>';
			
		$queryrows = db_fetch_assoc("select distinct id,title,imagecache from superlinks_pages, superlinks_auth where superlinks_pages.id=superlinks_auth.pageid and style='TAB' and (userid=".$_SESSION["sess_user_id"]." or userid=0) order by sortorder,id");	
	
		if(sizeof($queryrows) > 0)
		{
			foreach ($queryrows as $page) {
				$bluetab = "tab_".$page['imagecache'];
				$redtab = "red_".$page['imagecache'];

				// use the small tab images
				if($tabstyle == 1)
				{
					$bluetab = "s_".$bluetab;
					$redtab = "s_".$redtab;
				}
				
				$thetab = $bluetab;

				if(preg_match('/superlinks.php\?id=(\d+)/',$_SERVER['REQUEST_URI'] ,$matches))
				{
					if($matches[1]==$page['id'])
					{
						$thetab = $redtab;
					}
				}

				print "<a href=\"".$config['url_path']."plugins/superlinks/superlinks.php?id=".$page['id']."\"><img align=absmiddle border=0 src=\"".$config['url_path']."plugins/superlinks/tab_images/$thetab\" alt=\"".$page['title']."\" /></a>";
			}
		}
	}
}

function superlinks_setup_table () {
	global $config, $database_default;
	include_once($config["library_path"] . DIRECTORY_SEPARATOR . "database.php");

	$sql = "show tables";
	$result = db_fetch_assoc($sql) or die (mysql_error());

	$tables = array();
	$sql = array();

	foreach($result as $index => $arr) {
		foreach ($arr as $t) {
			$tables[] = $t;
		}
	}

	if (!in_array('superlinks_pages', $tables)) {
		$sql[] = "CREATE TABLE superlinks_pages(
			id int(11) NOT NULL auto_increment,
			sortorder int(11) NOT NULL default 0,
			contentfile text NOT NULL,
			title text NOT NULL,
			style varchar(10) NOT NULL DEFAULT 'TAB',
			imagecache varchar(60) NOT NULL DEFAULT '',
			PRIMARY KEY  (id)
		) TYPE=MyISAM;";
	}
	
	if (!in_array('superlinks_auth', $tables)) {
		$sql[] = "CREATE TABLE superlinks_auth (
			userid mediumint(9) NOT NULL default '0',
			pageid int(11) NOT NULL default '0'
		) TYPE=MyISAM;";
	}

	$sql[] = "UPDATE superlinks_pages SET sortorder=id WHERE sortorder IS NULL OR sortorder=0;";

	$tabstyle = read_config_option("superlinks_tabstyle");
        if($tabstyle == '' or $tabstyle < 0 or $tabstyle >1)
        {
                $sql[] = "replace into settings values('superlinks_tabstyle',0)";
        }


	if (!empty($sql)) {
		for ($a = 0; $a < count($sql); $a++) {
			$result = db_execute($sql[$a]);
		}
	}
}

function superlinks_draw_navigation_text ($nav) {
	global $superlinks_nav;

	if (sizeof($superlinks_nav)) {
		foreach($superlinks_nav as $key => $value) {
			$nav[$key] = $value;
		}
	}

//	$nav["superlinks.php:"] = array("title" => "SuperLinks", "mapping" => "", "url" => "superlinks.php", "level" => "1");
//	$nav["superlinks-mgmt.php:"] = array("title" => "SuperLinks Admin", "mapping" => "", "url" => "superlinks-mgmt.php", "level" => "1");
//	$nav["superlinks-mgmt.php:addpage_picker"] = array("title" => "SuperLinks Admin", "mapping" => "", "url" => "superlinks-mgmt.php", "level" => "1");
//	$nav["superlinks-mgmt.php:edit"] = array("title" => "SuperLinks Admin", "mapping" => "", "url" => "superlinks-mgmt.php", "level" => "1");
//	$nav["superlinks-mgmt.php:perms_edit"] = array("title" => "SuperLinks Admin", "mapping" => "", "url" => "superlinks-mgmt.php", "level" => "1");

	return $nav;
}

function superlinks_version () {
        return array( 'name'    => 'superlinks',
                        'version'       => '0.72',
                        'longname'      => 'SuperLinks',
                        'author'        => 'Howard Jones',
                        'homepage'      => 'http://wotsit.thingy.com/haj/cacti/superlinks-plugin.html',
                        'email' 		=> 	'howie@thingy.com',
                        'url'           => 'http://wotsit.thingy.com/haj/cacti/versions.php'
                        );
}

?>
